           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Act_prefix_cpo = Act_prefix + Domain_SF_prod_cpo:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]

(*****************************************************************

         1. [[a -> P]]T : continuous
         2. [[a -> P]]F : continuous
         3. 
         4. 

 *****************************************************************)

(*** Act_prefix_evalT_continuous ***)

lemma Act_prefix_evalT_continuous:
 "continuous [[P]]T ==> continuous [[a -> P]]T"
apply (simp add: continuous_iff)
apply (intro allI impI)
apply (drule_tac x="X" in spec, simp)
apply (elim conjE exE)
apply (rule_tac x="x" in exI, simp)

apply (subgoal_tac "X ~= {}")
apply (simp add: isLUB_UnionT)
apply (rule eq_iffI)

(* <= *)
apply (rule)
apply (simp add: memT_UnionT)
apply (simp only: Act_prefix_mem)
apply (erule disjE, fast)
apply (elim conjE exE)
apply (simp add: memT_UnionT)
apply (erule bexE)
 apply (rule_tac x="xa" in bexI)
 apply (rule_tac x="s" in exI, simp)
 apply (simp)

(* => *)
apply (rule)
apply (simp add: memT_UnionT)
apply (erule bexE)
apply (simp add: Act_prefix_mem)
apply (erule disjE, simp)
apply (elim conjE exE)
apply (rule disjI2)
apply (rule_tac x="s" in exI, simp)
apply (simp add: memT_UnionT)
apply (rule_tac x="xa" in bexI)
apply (simp_all)

by (simp add: directed_def)

(*** Act_prefix_evalF_continuous ***)

lemma Act_prefix_evalF_continuous:
 "continuous [[P]]F ==> continuous [[a -> P]]F"
apply (simp add: continuous_iff)
apply (intro allI impI)
apply (drule_tac x="X" in spec, simp)
apply (elim conjE exE)
apply (rule_tac x="x" in exI, simp)

apply (subgoal_tac "X ~= {}")
apply (simp add: isLUB_UnionF)
apply (rule eq_iffI)

(* <= *)
apply (rule)
apply (simp add: memF_UnionF)
apply (simp add: Act_prefix_mem)
apply (erule disjE, fast)
apply (elim conjE exE)
apply (simp add: memF_UnionF)
apply (erule bexE)
 apply (rule_tac x="xa" in bexI)
 apply (rule_tac x="sa" in exI, simp)
 apply (simp)

(* => *)
apply (rule)
apply (simp add: memF_UnionF)
apply (erule bexE)
apply (simp add: Act_prefix_mem)
apply (erule disjE, simp)
apply (elim conjE exE)
apply (rule disjI2)
apply (rule_tac x="sa" in exI, simp)
apply (simp add: memF_UnionF)
apply (rule_tac x="xa" in bexI)
apply (simp_all)

by (simp add: directed_def)

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]
declare disj_not1      [simp]
declare not_None_eq    [simp]

end
