           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM04_para = DM03_para:

(*****************************************************************

         1. expands parallel operators in Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** WR0 VAR step 4 ***)

lemma WR0_VAR: 
  "LET SysDef IN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n>)
   =F
   LET SysDef IN ? x:insert (WR0 (n div 2)) (insert (RD1 n) (range WR1))
     -> IF (x = WR0 (n div 2))
           THEN (<TH0> |[CH0]| <VAR (n div 2)>)
           ELSE IF (x = RD1 n)
                THEN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n>)
                ELSE (WR0 (n div 2) -> <TH0> |[CH0]| <VAR (getInt x)>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF WR0_VAR]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF WR0_VAR[simplified]]

(*** WR0 VAR TH1 step 4 ***)

lemma WR0_VAR_TH1: 
  "EVEN n ==>
   LET SysDef IN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
   =F
   LET SysDef IN ? x:{WR0 (n div 2), RD1 n}
      -> IF (x = WR0 (n div 2))
            THEN (<TH0>  |[CH0]| <VAR (n div 2)> |[CH1]| <TH1>)
            ELSE (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF WR0_VAR_TH1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF WR0_VAR_TH1[simplified]]

(*** EAT0 VAR Back1 step 4 ***)

lemma EAT0_VAR_Back1: 
  "EVEN n ==>
   LET SysDef IN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
   =F
   LET SysDef IN ? x:{End0, Back1} 
      -> IF (x = End0)
            THEN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
            ELSE (<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF EAT0_VAR_Back1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF EAT0_VAR_Back1[simplified]]

(*** TH0 VAR EAT1 step 4 ***)

lemma TH0_VAR_WR1: 
  "ODD n ==>
   LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
   =F
   LET SysDef IN ? x:{WR1 (3 * n + 1), RD0 n} 
   -> IF (x = WR1 (3 * n + 1))
         THEN (<TH0> |[CH0]| <VAR (3 * n + 1)> |[CH1]| <TH1>)
         ELSE (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF TH0_VAR_WR1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF TH0_VAR_WR1[simplified]]

(*** Back0 VAR EAT1 step 4 ***)

lemma Back0_VAR_EAT1: 
  "ODD n ==>
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
   =F
   LET SysDef IN ? x:{End1, Back0} 
   -> IF (x = End1)
         THEN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
         ELSE (<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  csp_rule_rw[OF Back0_VAR_EAT1]
lemmas fold_SYS_rules   = fold_SYS_rules    csp_rule_rev_rw[OF Back0_VAR_EAT1[simplified]]

end
